<template>
    <div>
        <app-profile-card
            v-for="profile in profiles"
            :key="profile.id"
            :profile="profile"
            class="hover:bg-gray-200"
        />

        <div v-if="profiles.length" v-observe-visibility="{callback: handleScrolledToBottom}">
            
        </div>

    </div>
</template>
<script>
import { mapGetters, mapActions } from 'vuex';
export default {
    props: {
        username: {
            required: true,
            type: String
        }
    },

    data() {
        return {
            page: 1,
            lastPage: 1
        }
    },

    computed: {
        ...mapGetters({
            profiles: 'profile/profiles',
        }),

        urlWithPage() {
            return `/api/profiles/${this.username}/followers?page=${this.page}`;
        }
    },

    methods: {
        ...mapActions({
            getProfiles: 'profile/getProfiles'
        }),

        loadProfiles() {
            this.getProfiles(this.urlWithPage).then(response => {
                this.lastPage = response.data.meta.last_page;
            });
        },

        handleScrolledToBottom(isVisible) {
            if(!isVisible) {
                return;
            }

            if(this.lastPage === this.page) {
                return;
            }

            this.page++;
            this.loadProfiles();
        }
    },

    mounted() {
        this.loadProfiles();
    }
}
</script>